;***************************************************************************
; Filename :  PROJ0201.ASM
; Description : Output port expansion by 74HC595 shift register 
; MCU : 	PIC12F675
; Hardware :	AX-12 PIC12F675 Activity board
; Written by :	Kridsada Jaiyen
; Copyright 2003 Innovative Experiment Co.,Ltd.
;***************************************************************************

	LIST      P=12F675,W=-302   	; list directive to define processor
	#INCLUDE <P12F675.INC>  	; processor specific variable definitions
	
	__CONFIG  0x01c4		; INTRC,WDT OFF,BROWNOUT OFF,MCLR OFF
	CBLOCK	0x20
	  DUMMY1,DUMMY2,COUNT,SEND,CNT
	ENDC

#DEFINE	DAT	GPIO,1		;***************************************
#DEFINE CLK	GPIO,4		; 74595 pin
#DEFINE LAT	GPIO,2		;*************************************** 

	ORG	0x000
INIT   	MOVLW	.7          	; Comparator off
 	MOVWF	CMCON					
	BANKSEL	ANSEL 		; //Bank 1		
	CALL	0x3FF		; Load OSC. from last address
	MOVWF	OSCCAL		; Tuning
  	CLRF	ANSEL		; GP4,GP2,GP1,GP0 = digital I/O
	MOVLW	B'11101000' 	; GP4,GP2,GP1,GP0 = output   
	MOVWF	TRISIO
	BANKSEL	GPIO		; //Bank 0

MAIN	CLRF	CNT
AGAIN	MOVF	CNT,W
	CALL	SEND8BIT
	CALL	DELAY
	INCF	CNT,f
	GOTO	AGAIN

;*********************************************
; SEND8BIT routine
; Send 8-bit data to shift register
;*********************************************
SEND8BIT MOVWF	SEND		; Load Data
	MOVLW	0x08		; Loop 8 Time : Send 8 Data Bit
	MOVWF	COUNT
CHK_BIT	BCF	DAT		; RB3 >> DATA PIN
	BTFSC	SEND,7		; Check bit 7 0 Or 1	
	BSF	DAT		; Send Bit 7 To Shift Register
CLOCK	BSF	CLK		; Clock Pulse
	BCF	CLK		
ROTATE	RLF	SEND,F		; Rotate Bit For Send Other Bit
	DECFSZ	COUNT,F		; Test Loop 8 Time ?
	GOTO	CHK_BIT		; If No Send Bit Again
LATCH	BSF	LAT		; Latch Data For Show Long Time
	BCF	LAT
	RETURN

DELAY	CLRF	DUMMY1
DELAY1	CLRF	DUMMY2
	DECFSZ	DUMMY2,F
	GOTO	$-1
	DECFSZ	DUMMY1,F
	GOTO	DELAY1
	RETURN
	
	END                    	; directive 'end of program'

