;*************************************************************************************
; Filename :  PROJ0701.ASM
; Description : Debug in PIC12F675
; MCU : 	PIC12F675
; Hardware :	AX-12 PIC12F675 Activity board
; Copyright 2003 Innovative Experiment Co.,Ltd.
;*************************************************************************************
	LIST	P=12F675,W=-302
	INCLUDE	P12F675.INC	
	INCLUDE	DEBUG675.INC	; For debug only 
	__CONFIG	0x11E4	; INTRC, WDT_OFF, MCLR_ON	

	CBLOCK	0x20
	  XX,YY
	    ENDC

	ORG	0x000	 

INITIAL	MOVLW	.7
 	MOVWF	CMCON	; Comparator off			
	BANKSEL	ANSEL	; Bank 1			
	CALL	0x3FF	; Load OSC. value 
	MOVWF	OSCCAL	; Calibrated OSC. 
	CLRF	ANSEL	; All port = digital i/O
	BANKSEL	GPIO	; Bank 0

AGAIN	CLRF	XX		
	MOVLW	.9
	MOVWF	YY	
	SETC 		; Carry flag = 1
LOOP	RRF	XX,1	; Shift XX  
	DECF	YY,1	; Decrease YY
	CALL	SHOW 	; Show value of XX and YY 
	TSTF	YY	; Teat file YY = 0 ?		
	BNZ	LOOP	; No, then loop
	GOTO	AGAIN	; Yes, then again 
	
SHOW	DEBUG	"X","-","V","a","l",".", XX, 0 ; Debug XX without delay
	DEBUG	"Y","-","V","a","l",".", YY, 5 ; Debug YY with 1 second delay	RETURN
	END

