;*************************************************************************************
; Filename :  PROJ0702.ASM
; Description : Debug  ADC module in PIC12F675
; MCU : 	PIC12F675
; Hardware :	AX-12 PIC12F675 Activity board
; Written by : Natthapol Wongsoonthornchai
; Copyright 2003 Innovative Experiment Co.,Ltd. 
;*************************************************************************************
	LIST	P=12F675,W=-302
	INCLUDE	P12F675.INC
	INCLUDE	DEBUG675.INC
	__CONFIG	0x31E4	; INTRC 4 MHz., WDT off, MCLR on

	ORG	0x000	
	
INITIAL_PORT	MOVLW	.7	
	MOVWF	CMCON	; Comparator off	
	BANKSEL	ANSEL	; Select bank 1			
	CALL	0x3FF	; Load OSC. value
	MOVWF	OSCCAL	; Calibrate here
	MOVLW	B'01111111'	; fRC = 500 kHZ,GP4,GP2:GP0 = analog input
	MOVWF	ANSEL	
	BSF	INTCON,PEIE	; Peripheral interrupt enable
	BSF	PIE1,ADIE	; ADC interrupt enable
	BANKSEL	GPIO	; Return to bank 0
	
MAIN_PROG	MOVLW	B'00000000'	; Select CH0
	CALL	ADC
	MOVFW	ADRESH	; W = high-byte result (2-bit) 
	CALL	RESULT_HIGH	; Show high-byte result(2-bit)
	BANKSEL	ADRESL	; Selct bank1
	MOVFW	ADRESL	; W = low-byte result (8-bit)
	CALL	RESULT_LOW	; Show low-byte result (8-bit)	
	GOTO	MAIN_PROG	; Do again

ADC	MOVWF	ADCON0	; Select ADC channel.,Vref = Vdd
	BSF	ADCON0,ADFM	; Right justified (B'000000xXXXXXXXXX')
	BSF	ADCON0,ADON	; Enable ADC module
	GOTO	$+1	; Delay ~10 microsecond for TACQ
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1
	GOTO	$+1	
	BSF	ADCON0,GO	; Start conversion
	NOP
	SLEEP		; Enter sleep mode
	BCF	PIR1,ADIF	; Clear ADC flag after wake-up
	BCF	ADCON0,ADON	; Disable ADC module
	RETURN				

RESULT_HIGH	DEBUG	'R','E','S','_','H','>', ADRESH, .00	; Without delay
	RETURN	
RESULT_LOW	DEBUG	'R','E','S','_','L','>', ADRESL, .10	; Delay 2 seconds	
	RETURN
	END

