;*************************************************************************************
; Filename :  PROJ14.ASM
; Description : Drive 12-LED with only 4 I/O pins of PIC12F675 
; MCU : 	PIC12F675
; Hardware :	AX-12 PIC12F675 Activity board
; Written by : Natthapol Wongsoonthornchai
; Copyright 2003 Innovative Experiment Co.,Ltd.
;************************************************************************************

	LIST	P=12F675,W=-302 
	INCLUDE	P12F675.INC
	__CONFIG	0x3184	; INTRC 4 Mhz., WDT off, MCLR off
LED_VALUE	EQU	0x20
	ORG	0x000	
	
INIT_PORT	MOVLW	.7	; Comparator off
	MOVWF	CMCON		
	CLRF	GPIO	; Clear GPIO latch
	BANKSEL	OSCCAL	; Bank 1  			
	CALL	0x3FF	; Load OSC. value
	MOVWF	OSCCAL	; Calibrate here
	CLRF	ANSEL	
	BANKSEL	GPIO	; Bank 0
	
AGAIN	MOVLW	.11	; Start LED #11
	MOVWF	LED_VALUE
LOOP	CALL	TABLE
	CALL	DELAY
	DECFSZ	LED_VALUE,1	
	GOTO	LOOP
	CALL	TABLE	; Turn on LED #0
	CALL	DELAY
	GOTO	AGAIN	; Do again

TABLE	MOVFW	LED_VALUE
	CALL	TABLE_TRISIO
	BANKSEL	TRISIO	; Bank 1
	MOVWF	TRISIO
	MOVFW	LED_VALUE
	CALL	TABLE_GPIO
	BANKSEL	GPIO	; Bank 0
	MOVWF	GPIO
	RETURN
	
TABLE_TRISIO	ADDWF	PCL,1	
	RETLW	B'11111100'	; LED0
	RETLW	B'11111100'	; LED1
	RETLW	B'11111001'	; LED2
	RETLW	B'11111001'	; LED3
	RETLW	B'11101011'	; LED4
	RETLW	B'11101011'	; LED5	
	RETLW	B'11111010'	; LED6
	RETLW	B'11111010'	; LED7	
	RETLW	B'11101110'	; LED8
	RETLW	B'11101110'	; LED9
	RETLW	B'11101101'	; LED10	
	RETLW	B'11101101'	; LED11
	
TABLE_GPIO	ADDWF	PCL,1
	RETLW	B'00000001'	; LED #0
	RETLW	B'00000010'	; LED #1
	RETLW	B'00000010'	; LED #2
	RETLW	B'00000100'	; LED #3
	RETLW	B'00000100'	; LED #4	
	RETLW	B'00010000'	; LED #5
	RETLW	B'00000001'	; LED #6	
	RETLW	B'00000100'	; LED #7	
	RETLW	B'00000001'	; LED #8	
	RETLW	B'00010000'	; LED #9
	RETLW	B'00000010'	; LED #10
	RETLW	B'00010000'	; LED #11

DELAY	CLRF	0x21
	CLRF	0x22
	MOVLW	.2
	MOVWF	0x23
	DECFSZ	0x21,1
	GOTO	$-1
	DECFSZ	0x22,1
	GOTO	$-3
	DECFSZ	0x23,1
	GOTO	$-5
	RETURN

	END
